leetcode 11. 盛最多水的容器 -java

给定一个长度为 n 的整数数组 height 。有 n 条垂线,第 i 条线的两个端点是 (i, 0) 和 (i, heighti) 。

找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。

返回容器可以储存的最大水量。

说明:你不能倾斜容器。

代码:

复制代码
public static void main(String[] args) {
    int[] height = new int[]{1,8,6,2,5,4,8,3,7};
    // 思路: 两个指针 leftIndex rightIndex  水的面积 = min(height[leftIndex],height[rightIndex]) * (rightIndex-leftIndex) 循环比较获取较大的那个面积
    Integer maxSize = 0;
    for (int leftIndex = 1; leftIndex < height.length+1 ; leftIndex++) {
        for (int rightIndex = 1; rightIndex < height.length+1 ; rightIndex++) {
            maxSize = Math.max(maxSize,Math.min(height[leftIndex],height[rightIndex])*(rightIndex-leftIndex));
        }
    }
    return maxSize;

}

双层for循环嵌套-超出时间限制

改进:接水 - 接多少水取决于短版的长度,所以可以使用双指针法,每次比较,保留较大元素的指针不动,较小元素的指针平移寻找更大的指针,直到两个指针相遇

这是因为木桶底部长度在指针在两头时是最大的,指针内移x轴长度一定会减小,这时如果想要获取更大面积,需要获取两个height里较小的那个,让他增大,面积才会增大,所以较小的元素的指针向内循环,寻找更大的值,一直到左右两个指针重合,结束循环

代码:

复制代码
public static void main(String[] args) {
    int[] height = new int[]{1,8,6,2,5,4,8,3,7};

    int left = 0, right = height.length - 1;
    int ans = 0;
    while (left < right) {
        int area = Math.min(height[left], height[right]) * (right - left);
        ans = Math.max(ans, area);
        if (height[left] <= height[right]) {
            ++left;
        }
        else {
            --right;
        }
    }
    return ans;
}

思考:遇到双层for循环,需要思考能否用双指针解决性能问题

相关推荐
sunshine22 girl1 小时前
Java学习七 Java 项目实战2-注册业务
java·学习
奋发向前wcx2 小时前
CSP-J复赛模拟赛4 王晨旭补题 2026.10.5
算法
省钱兄--zs2 小时前
北京24小时自助健身房系统软件开发实战:从架构设计到部署指南
java·数据仓库·spring boot·小程序·需求分析
youdexiang2 小时前
Android录音软件时间关键词检索功能分析
java·人工智能
sunshine22 girl3 小时前
Java学习七 Java 项目实战1-项目创建和主页面搭建
java·开发语言·学习
code2cat3 小时前
Java进阶篇之AtomicStampedReference:引用回到原值,版本戳仍能记住变化
java·cas·并发编程·aba
念何架构之路4 小时前
zap采样器与性能优化内幕
算法·性能优化·哈希算法
泡茶喝茶写代码5 小时前
A股量化数据工程:从 REST 接口到策略信号(第 8 篇):成长能力因子:营收与利润增速
java·python·股票数据api·股票数据api接口·股票量化数据api·股票量化数据接口·股票数据api数据
晒太羊的猫5 小时前
hot100动态规划刷题
算法·动态规划
\光辉岁月/5 小时前
7.javase-面向对象
java·开发语言